// ############################################################################
//
// File:    $Header: DioSoftPorts.h$
// Author:  Advantech
// Created: 05/30/05(mm/dd/yy)
//
// Description: Include some header used by console programming and declare 
//          some functions necessary.
// ----------------------------------------------------------------------------
#ifndef DIOSOFTPORTS_H
#define DIOSOFTPORTS_H

#include <windows.h>
#include <iostream.h>

#include "..\..\..\include\driver.h"

// ======================================================================
// Name: ShowDevList
// Description:  Show the list of installed devices. 
// ----------------------------------------------------------------------
BOOL ShowDevList ( DWORD * *dwpDevNumList, SHORT & sDevCount);

// ======================================================================
// Name: Select device
// Description:  Select a device according to the number user input and 
//    return the device handle if successful, otherwise return 0. 
// ----------------------------------------------------------------------
LONG SelectDevice ( SHORT sDevCount );

// ======================================================================
// Name: ErrReport
// Description:  Report error message in more details.
// ----------------------------------------------------------------------
void ErrReport ( LRESULT lErrCde );

// ======================================================================
// Name: SelectPort
// Description:  Select the number of start port and port count for DI 
//             operation.
// ----------------------------------------------------------------------
void SelectPort (DWORD & lStartPort, DWORD & lPortCount, DWORD lMaxCount );


// ======================================================================
// Name: ReadPorts
// Description: Read the selected ports.
// ----------------------------------------------------------------------
BOOL ReadPorts ( LONG lDevHandle, DWORD lPortStart, DWORD lPortCount );

// ======================================================================
// Name: ClearStream
// Description: Empty the get stream.
// ----------------------------------------------------------------------
void ClearStream ();

// ======================================================================
// Name: InputNumStream
// Description: Input the numbers and empty the get stream.
// ----------------------------------------------------------------------
void InputNumStream ( DWORD & dwNum );



#endif